<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter"
      :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true" label-width="100px">
            <el-form-item label="供应商" prop="productorId">
              <el-select v-model="queryParams.productorId" clearable placeholder="请选择供应商">
                <el-option v-for="dict in dictGroup.productorOptions" :key="dict.id" :label="dict.name"
                  :value="dict.id"></el-option>
              </el-select>
            </el-form-item>
            <el-form-item label="姓名" prop="name">
              <el-input v-model="queryParams.name" placeholder="请输入姓名" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery"> 搜索 </el-button>
              <el-button icon="Refresh" @click="resetQuery"> 重置 </el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd"> 新增 </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"> 修改 </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"> 删除 </el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @query-table="getList" />
        </el-row>
      </template>

      <el-table v-loading="loading" :data="tableList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="售后工程师" align="center" prop="name" width="150" />
        <el-table-column label="供应商" align="center"  width="150" >
          <template #default="scope">
            {{ formatDict(scope.row.productorId, 'productorOptions') }}
          </template>
        </el-table-column>
        <el-table-column label="联系电话" align="center" prop="phone" width="150" />
        <el-table-column label="负责设备" align="center" prop="deviceTypeIds" show-overflow-tooltip width="150" >
          <template #default="scope">
            {{formatDevice(scope.row.deviceTypeIds)}}
          </template>
        </el-table-column>
        <el-table-column label="所在城市" align="center" prop="city" width="100" />
        <el-table-column label="详细地址" align="center" prop="address" show-overflow-tooltip width="180" />
        <el-table-column label="备注" align="center" show-overflow-tooltip prop="remark" width="150" />
        <el-table-column label="创建时间" align="center" prop="createTime" width="180" />
        <el-table-column label="操作" align="center" width="100" fixed="right" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button size="small" link type="primary" @click="handleUpdate(scope.row)">修改</el-button>
            <el-button size="small" link type="danger" @click="handleDelete(scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="total > 0" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
        :total="total" @pagination="getList" />
    </el-card>
    <!-- 添加或修改对话框 -->
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="800px" append-to-body>
      <el-form ref="addFormRef" :model="form" label-width="100px">
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="供应商" prop="productorId"
              :rules="[{ required: true, message: '供应商不能为空', trigger: 'change' }]">
              <el-select v-model="form.productorId" clearable placeholder="请选择供应商" @change="productorChange">
                <el-option v-for="dict in dictGroup.productorOptions" :key="dict.id" :label="dict.name"
                  :value="dict.id"></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="姓名" prop="name" :rules="[{ required: true, message: '姓名不能为空', trigger: 'blur' }]">
              <el-input v-model="form.name" placeholder="请输入姓名" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="联系电话" prop="phone" :rules="[{ required: true, message: '联系电话不能为空', trigger: 'blur' }]">
              <el-input v-model="form.phone" placeholder="请输入联系电话" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="负责设备" prop="deviceTypeIds"
              :rules="[{ required: true, message: '负责设备不能为空', trigger: 'change' }]">
              <el-select v-model="form.deviceTypeIds" multiple clearable placeholder="请选择负责设备">
                <el-option v-for="dict in dictGroup.deviceTypeDetailOptions" :key="dict.id"
                  :label="`${dict.ext1.brand}${dict.xh}`" :value="dict.id">
                  <span style="float: left">{{ dict.ext1.brand }}</span>
                  <span style="float: right;color: var(--el-text-color-secondary);font-size: 13px;">
                    {{ dict.xh }}
                  </span>
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="地区" prop="city">
              <el-input v-model="form.city" placeholder="请输入地区" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="详细地址" prop="address">
              <el-input v-model="form.address" placeholder="请输入详细地址" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="备注" prop="remark">
              <el-input v-model="form.remark" type="textarea" placeholder="请输入备注" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm"> 确 定 </el-button>
          <el-button @click="cancel"> 取 消 </el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="ServiceEngineer" lang="ts">
import { listProductor, listProductorEngineers, getProductorEngineers, delProductorEngineers, addProductorEngineers, updateProductorEngineers } from '@/api/supplierManage/index';
import {
  getDeviceTypeDetailList
} from '@/api/deviceManage/deviceType';
const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const tableList = ref([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const queryFormRef = ref<ElFormInstance>();
const addFormRef = ref<ElFormInstance>();
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
const dictGroup = reactive({
  productorOptions: [],
  deviceTypeDetailOptions: []
})
const initFormData = {
  id: undefined,
  name: undefined,
  phone: undefined,
  productorId: undefined,
  deviceTypeIds: [],
  city: undefined,
  address: undefined,
  remark: undefined,
  ext1: <any>{},
  ext2: undefined
};
const formData = reactive({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    name: undefined,
    productorId: undefined,
    params: {}
  }
});

const { queryParams, form } = toRefs(formData);

/** 查询列表 */
const getList = async () => {
  loading.value = true;
  const res = await listProductorEngineers(queryParams.value);
  tableList.value = res.rows.map((item) => ({
    ...item,
    ext1: item.ext1 ? JSON.parse(item.ext1) : null
  }));
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  addFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '新增售后工程师';
};

/** 修改按钮操作 */
const handleUpdate = async (row) => {
  reset();
  const _id = row?.id || ids.value[0];
  const { data } = await getProductorEngineers(_id);
  data.ext1 = data.ext1 && JSON.parse(data.ext1);
  deviceTypeDetailList(data.productorId)
  data.deviceTypeIds = data.deviceTypeIds.split(',');
  Object.assign(form.value, data);
  dialog.visible = true;
  dialog.title = '修改售后工程师';
};

/** 提交按钮 */
const submitForm = () => {
  addFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      const { ext1, deviceTypeIds } = form.value;
      const params = Object.assign(form.value, { ext1: JSON.stringify(ext1), deviceTypeIds: deviceTypeIds.join() });
      if (form.value.id) {
        await updateProductorEngineers(params).finally(() => (buttonLoading.value = false));
      } else {
        await addProductorEngineers(params).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除？').finally(() => (loading.value = false));
  await delProductorEngineers(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};
const getProductorList = async () => {
  const res = await listProductor({});
  dictGroup.productorOptions = res.rows;
};
const deviceTypeDetailList = async (productorId = '') => {
  const res = await getDeviceTypeDetailList({ productorId });
  dictGroup.deviceTypeDetailOptions = res.rows.map((item) => ({
    ...item,
    ext1: item.ext1 ? JSON.parse(item.ext1) : null
  }));
};
const productorChange = (val) => {
  deviceTypeDetailList(val)
  form.value.deviceTypeIds = []
}
const formatDevice = (val) => {
  const arr = val.split(',')
  let label = ''
  dictGroup.deviceTypeDetailOptions.forEach((item) => {
    arr.forEach(el => {
      if (el===item.id) {
        label +=`${item.ext1.brand}${item.xh},`
      }
    })
  })
  return label.substring(0,label.length-1)
}
const formatDict = (val, option: string) => {
  let label = '';
  dictGroup[option].forEach((item) => {
    if (val === item.id) {
      label = item.name;
    }
  });
  return label;
};
onMounted(() => {
  getList();
  getProductorList()
  deviceTypeDetailList()
});
</script>
<style lang="scss" scoped>
.card-header {
  display: flex;
  justify-content: space-between;

  .el-icon {
    cursor: pointer;
  }
}

.custom-tree-node {
  flex: 1;
  display: flex;
  justify-content: space-between;
  align-items: center;
  padding-right: 5px;
}

.node-operateBtns {
  div {
    margin-top: 3px;
    text-align: center;
    cursor: pointer;

    &:hover {
      color: #409eff;
    }
  }
}
</style>
<style lang="scss">
.customDrawer {
  .el-drawer__header {
    align-items: flex-start !important;
    margin-bottom: 10px;

    .drawer-title {
      .title-name {
        color: #000;
      }
    }
  }

  .el-drawer__body {
    padding-top: 0;
  }
}
</style>
